#Election model 2019 edition by Neel Ocean (www.neelocean.com)

from __future__ import print_function
import csv
import random

with open('2019electionBBC.csv') as csvfile:
    read = csv.reader(csvfile, delimiter=',')
    statements = list(read)
    numrows = len(statements)

random.shuffle(statements)

print("\nFor each statement, please input a number from -2 to 2 according to the following key:\n")
print("-2 = Strongly Disagree\n-1 = Disagree\n0 = Indifferent or don't know\n1 = Agree\n2 = Strongly Agree\n")
print("\n-----------------------------------------\n")

for i in range(0, numrows-1):
    print("\nStatement", i+1, "of", numrows, "\nHow strongly do you agree/disagree with the following:\n\n" + statements[i][2])
    x = input("\nPlease rate from -2 to 2: ")
    while x == '':
        x = input("That is not a valid input. Please input a number from -2 to 2: ")
    xnum = float(x)
    while xnum > 2 or xnum < -2:
        xnum = float(input("That number is not in range. Please rate from -2 to 2: "))
    statements[i].append(xnum)

con_total = 0
lab_total = 0
lib_total = 0
ukip_total = 0
green_total = 0
change_total = 0
brexit_total = 0

con_score = 0
lab_score = 0
lib_score = 0
ukip_score = 0
green_score = 0
change_score = 0
brexit_score = 0

for i in range(0, numrows-1):
    con_total = con_total + statements[i].count("Con")
    lab_total = lab_total + statements[i].count("Lab")
    lib_total = lib_total + statements[i].count("Lib")
    ukip_total = ukip_total + statements[i].count("UKIP")
    green_total = green_total + statements[i].count("Green")
    change_total = change_total + statements[i].count("Change")
    brexit_total = brexit_total + statements[i].count("Brexit")

for i in range(0, numrows-1):
    if statements[i][1] == "Con":
        con_score = con_score + statements[i][3]
    elif statements[i][1] == "Lab":
        lab_score = lab_score + statements[i][3]
    elif statements[i][1] == "Lib":
        lib_score = lib_score + statements[i][3]
    elif statements[i][1] == "UKIP":
        ukip_score = ukip_score + statements[i][3]
    elif statements[i][1] == "Change":
        change_score = change_score + statements[i][3]
    elif statements[i][1] == "Brexit":
        brexit_score = brexit_score + statements[i][3]
    else:
        green_score = green_score + statements[i][3]

gr = green_score/green_total
uk = ukip_score/ukip_total
li = lib_score/lib_total
la = lab_score/lab_total
co = con_score/con_total
ch = change_score/change_total
br = brexit_score/brexit_total

m = max(gr, uk, li, la, co, ch, br)
parties = [['Green Party', gr], ['UKIP', uk], ['Liberal Democrat', li], ['Labour', la], ['Conservative', co], ['Change', ch], ['Brexit', br]]
party = []

for i in range(0, 7):
    if parties[i][1] == m:
        party.append(parties[i][0])

num_party = len(party)

if num_party == 1:
    print("\n\nYour scores suggest that you should vote", party[0])
else:
    print("\n\nYour scores suggest that you should vote for one of the following parties:")
    for i in range(0, num_party):
        print(party[i])

print("\nFor reference, here are your scores for each party:")
print("Conservative: ", co)
print("Labour: ", la)
print("Liberal Democrat: ", li)
print("UKIP: ", uk)
print("Green: ", gr)
print("Change: ", ch)
print("Brexit: ", br)